package cn.com.taiji.service.impl;

import cn.com.taiji.enetity.HlxAis;
import cn.com.taiji.mapper.HlxAisMapper;
import cn.com.taiji.model.HlxAisPackage;
import cn.com.taiji.model.HlxHead;
import cn.com.taiji.model.HlxRadarPackage;
import cn.com.taiji.service.HlxAisService;
import cn.com.taiji.utils.ByteArrayUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @author kok20
 * @date 2023/3/3
 */@Service
@Slf4j
public class HlxAisServiceImpl extends ServiceImpl<HlxAisMapper, HlxAis> implements HlxAisService {
    private Vector<HlxAisPackage> targetAis = new Vector<>();
    private Vector<HlxRadarPackage> targetRadar = new Vector<>();

    @Override
    public void putAisList(HlxAisPackage p) {
        targetAis.add(p);
    }

    @Override
     public List<HlxAisPackage> getAisList() {
        List<HlxAisPackage> result = new ArrayList<> (targetAis);
        targetAis.clear();
        return result;
     }

    @Override
    public void putRadarList(HlxRadarPackage p) {
        targetRadar.add(p);
    }

    @Override
    public List<HlxRadarPackage> getRadarList() {
        List<HlxRadarPackage> result = new ArrayList<> (targetRadar);
        targetRadar.clear();
        return result;
    }

    @Override
    public HlxHead getHeadFromByte(byte[] head) {
        HlxHead hlxHead = new HlxHead();
        if(head.length == 21){
            byte[] num = new byte[8];
            System.arraycopy(head,0,num,0,8);
            hlxHead.setNum(ByteArrayUtils.byteArray2Long_Little_Endian(num));
            byte[] timestamp = new byte[8];
            System.arraycopy(head,8,timestamp,0,8);
            Long stamp = ByteArrayUtils.byteArray2Long_Little_Endian(timestamp);
            Date time = new Date();
            time.setTime(stamp);
            hlxHead.setTimestamp(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss")
                    .format(time));
            byte[] type = new byte[1];
            System.arraycopy(head,16,type,0,1);
            int t = type[0]&255;
            hlxHead.setType(t);
            byte[] length = new byte[4];
            System.arraycopy(head,17,length,0,4);
            hlxHead.setLength(ByteArrayUtils.byteArray2Int_Little_Endian(length));
        }
        return hlxHead;
    }

    public static void main(String[] args) {

        byte[] result = new byte[21];
        result[0] = 0x69;
        result[1] = 0x20;
        result[2] = (byte) 0x91;
        result[3] = 0x01;
        result[4] = 0x00;
        result[5] = 0x00;
        result[6] = 0x00;
        result[7] = 0x00;
        result[8] = (byte) 0xFD;
        result[9] = 0x1C;
        result[10] = 0x0C;
        result[11] = (byte) 0xA8;
        result[12] = (byte) 0x86;
        result[13] = (byte) 0x01;
        result[14] = (byte) 0x00;
        result[15] = (byte) 0x00;
        result[16] = (byte) 0x02;
        result[17] = (byte) 0x4E;
        result[18] = (byte) 0x00;
        result[19] = (byte) 0x00;
        result[20] = (byte) 0x00;
        System.out.println("protobuf数据bytes[]:" + ByteArrayUtils.bytes2hexDisplayHex(result));
//        byte[] num = new byte[8];
//        System.arraycopy(result,0,num,0,8);
//        System.out.println("num:" + ByteArrayUtils.byteArray2Long_Little_Endian(num));
//        byte[] timestamp = new byte[8];
//        System.arraycopy(result,8,timestamp,0,8);
//        System.out.println("timestamp:" + ByteArrayUtils.byteArray2Long_Little_Endian(timestamp));
//        byte[] type = new byte[1];
//        System.arraycopy(result,16,type,0,1);
//        int i = type[0]&255;
//        System.out.println("type:" + i);
//        byte[] lenth = new byte[4];
//        System.arraycopy(result,17,lenth,0,4);
//        System.out.println("lenth:" + ByteArrayUtils.byteArray2Int_Little_Endian(lenth));
    }
}
